/*
 *======================================================================
 *
 *Copyright 1992 Sun Microsystems, Inc.
 *
 *The Interface Definition Language Compiler Front End (CFE) is made
 *available for use provided that this legend is included on all media and
 *documentation and as a part of the software program in whole or part.
 *Users may copy and extend functionality (but may not remove
 *functionality) of the Interface Definition Language CFE without charge,
 *but are not authorized to license or distribute it to anyone else except
 *as part of a product or program developed by the user or with the express
 *written consent of Sun Microsystems, Inc.
 *
 *The names of Sun Microsystems, Inc. and any of its subsidiaries may not
 *be used in advertising or publicity pertaining to distribution of
 *Interface Definition Language CFE as permitted herein.
 *
 *The Interface Definition Language CFE may not be exported outside the
 *United States without first obtaining the appropriate government
 *approvals.
 *
 *INTERFACE DEFINITION LANGUAGE CFE IS PROVIDED AS IS WITH NO WARRANTIES
 *OF ANY KIND INCLUDING THE WARRANTIES OF DESIGN, MERCHANTIBILITY AND
 *FITNESS FOR A PARTICULAR PURPOSE, NONINFRINGEMENT, OR ARISING FROM A
 *COURSE OF DEALING, USAGE OR TRADE PRACTICE.
 *
 *Interface Definition Language CFE is provided with no support and
 *without any obligation on the part of Sun Microsystems, Inc. or any of
 *its subsidiaries or affiliates to assist in its use, correction,
 *modification or enhancement.
 *
 *SUN MICROSYSTEMS, INC. OR ANY OF ITS SUBSIDIARIES OR AFFILIATES SHALL
 *HAVE NO LIABILITY WITH RESPECT TO THE INFRINGEMENT OF COPYRIGHTS, TRADE
 *SECRETS OR ANY PATENTS BY INTERFACE DEFINITION LANGUAGE CFE OR ANY PART
 *THEREOF.
 *
 *IN NO EVENT WILL SUN MICROSYSTEMS, INC. OR ANY OF ITS SUBSIDIARIES OR
 *AFFILIATES BE LIABLE FOR ANY LOST REVENUE OR PROFITS OR OTHER SPECIAL,
 *INDIRECT AND CONSEQUENTIAL DAMAGES, EVEN IF SUN HAS BEEN ADVISED OF THE
 *POSSIBILITY OF SUCH DAMAGES.
 *
 *SunSoft, Inc.  
 *2550 Garcia Avenue 
 *Mountain View, California  94043
 *
 *
 *
 *
 *======================================================================
 */

#ifndef _AST_AST_HH
#define _AST_AST_HH

#pragma ident "%@(#)ast.h	1.41% %92/06/10% Sun Microsystems"

// ast.h
//
// Defines the classes which constitute the agreement between the CFE
// and BEs.

/*
** DEPENDENCIES: NONE
**
** USE: Included from idl.hh
*/

#include	<utl_scoped_name.hh>	// Define UTL_ScopedName

#include	<ast_decl.hh>		// class AST_Decl

#include	<ast_expression.hh>	// class AST_Expression

#include	<utl_scope.hh>		// class UTL_Scope

#include	<ast_type.hh>		// class AST_Type
#include	<ast_concrete_type.hh>	// class AST_ConcreteType
#include	<ast_predefined_type.hh>// class AST_PredefinedType
#include	<ast_module.hh>		// class AST_Module
#include	<ast_root.hh>		// class AST_Root
#include	<ast_interface.hh>	// class AST_Interface
#include	<ast_interface_fwd.hh>	// class AST_InterfaceFwd
#include	<ast_exception.hh>	// class AST_Exception
#include	<ast_structure.hh>	// class AST_Structure
#include	<ast_enum.hh>		// class AST_Enum
#include	<ast_operation.hh>	// class AST_Operation
#include	<ast_field.hh>		// class AST_Field
#include	<ast_argument.hh>	// class AST_Argument
#include	<ast_attribute.hh>	// class AST_Attribute
#include	<ast_union.hh>		// class AST_Union
#include	<ast_union_branch.hh>	// class AST_UnionBranch
#include	<ast_union_label.hh>	// class AST_UnionLabel
#include	<ast_constant.hh>	// class AST_Constant
#include	<ast_enum_val.hh>	// class AST_EnumVal
#include	<ast_array.hh>		// class AST_Array
#include	<ast_sequence.hh>	// class AST_Sequence
#include	<ast_string.hh>		// class AST_String
#include	<ast_typedef.hh>	// class AST_Typedef 

#include	<utl_list.hh>		// class UTL_List
#include	<utl_strlist.hh>	// class UTL_StrList
#include	<utl_exprlist.hh>	// class UTL_ExprList

#include	<ast_generator.hh>	// class AST_Generator

#endif           // _AST_AST_HH
